/******************************************************************************
  ezht - Copyright (C) 2004 Tradcrafts
  This file is part of the ezht.
                                                                       
  ezht is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by the 
  Free Software Foundation;   either version 2 of the License,  or (at your 
  option) any later version.

  ezht is distributed in the hope that it will be useful, but 
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along with
  this program; see the file COPYING.  If not, write to the Free Software 
  Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/

#include <stdarg.h>
#include "reader.h"

void error(const char *fmt, ...)
{
  const char *fnam = reader.get_fnam();
  int   linenum = reader.get_linenum();
  
  if( fnam )
    fprintf(stderr,"%s[%d]: ",fnam,linenum);

  va_list arg;
  va_start(arg,fmt);
  vfprintf(stderr,fmt,arg);
  va_end(arg);

  fprintf(stderr,"\n");
  
  exit(-1);
}

void warn(const char *fmt, ...)
{
  const char *fnam = reader.get_fnam();
  int   linenum = reader.get_linenum();
  
  if( fnam )
    fprintf(stderr,"WARNING: %s[%d]: ",fnam,linenum);

  va_list arg;
  va_start(arg,fmt);
  vfprintf(stderr,fmt,arg);
  va_end(arg);

  fprintf(stderr,"\n");
}

