/******************************************************************************
  ezht - Copyright (C) 2004 Tradcrafts
  This file is part of the ezht.
                                                                       
  ezht is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by the 
  Free Software Foundation;   either version 2 of the License,  or (at your 
  option) any later version.

  ezht is distributed in the hope that it will be useful, but 
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along with
  this program; see the file COPYING.  If not, write to the Free Software 
  Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/

#include <unistd.h>
#include <string.h>
#include <ctype.h>
#include <list>
#include <string>


/* ǽ˻ʸ('?'ޤǤ褤ˤθݥ
ʸĤʤУΣգ̡̣ˤ֤*/
static const char * StrChr(const char *s,int c)
{
  if(c=='?')
    return (*s)!='\0' ? s : 0;
  return strchr(s,c);
}

/* ʸ d磻ɥɤޤʸ s ˰פп֤ */
static int WildMatch(const char *d,const char *s)
{

  for(;*s!='\0';s++)
    switch(*s){
    case '*':
      while(*(++s)=='*')
	;
      if(*s=='\0')
	return 1; //matches
      d=StrChr(d,*s);
      if( !d )
	return 0;//unmatched
      do{
	if(WildMatch(d,s))
	  return 1;
      }while(NULL!=(d=StrChr(d+1,*s)));
      return 0;
    case '?':
      if( *d++ == '\0' )
	return 0;
      break;
    default:
      if( *s != *d++ )
	return 0;
      break;
    }
  return *d=='\0';
}

#include <string.h>
#include <dirent.h>
#include <sys/stat.h>

struct listdirstruc
{
  bool isdir;
  bool iswild;
  std::string name;
};
  
static int __listdir(const char *dirnam, std::list<listdirstruc> patlist,
		     int ind,std::list<std::string> &list);

static inline bool ischild(const char *fname)
{
  if( strcmp(fname,".")==0 || strcmp(fname,"..")==0 )
    return false;
  else
    return true;
}

#define TEMPBUF_SIZE 2048
static char tempbuf[TEMPBUF_SIZE];

int ezht_glob(const char *pattern,std::list<std::string> &results)
{
  std::list<listdirstruc> patlist;
  listdirstruc *p;
  int i,j,len;
  bool iswild;
  char c;

  len = strlen(pattern);

  if(len==0)
    return 0;

  
  if( pattern[0]=='/' ){
    listdirstruc s;
    s.name = "/";
    s.iswild = false;
    s.isdir  = true;
    patlist.push_back(s);
    i=1;
  }
  else
    i=0;

  for( ; i<len ;i++){
    iswild = false;
    j = i;
    while( (c=pattern[i])!='/' && c!='\0'){
      if( c=='*' || c=='?' )
	iswild = true;
      i++;
    }
    if(j!=i){
      listdirstruc s;
      s.iswild = iswild;
      s.isdir  = true;
      strncpy(tempbuf,pattern+j,i-j);
      tempbuf[i-j]='\0';
      s.name = tempbuf;
      patlist.push_back(s);
    }
  }
    
  std::list<listdirstruc>::iterator term=patlist.end();
  --term;
  for(std::list<listdirstruc>::iterator cur=patlist.begin(); cur!=term;){
    std::list<listdirstruc>::iterator next = cur;
    ++next;
    if( ! (*cur).iswild && ! (*next).iswild ){
      if( (*cur).name == "/" )
	(*cur).name += (*next).name;
      else
	(*cur).name += "/" + (*next).name;
      if( next == term )
	break;
      patlist.erase(next);
    }
    else
      cur++;
  }

  (*patlist.rbegin()).isdir = false;
  
  DIR *dirp;
  struct dirent *ent;
  
  int nmatched = 0;
  p = & (*patlist.begin());


  if( p->isdir ){
    if( p->iswild ){
      getcwd(tempbuf,TEMPBUF_SIZE);
      dirp = opendir(tempbuf);
      if( dirp ){
	while( (ent=readdir(dirp)) != NULL )
	  if( ischild(ent->d_name) && WildMatch(ent->d_name,p->name.c_str()) )
	    nmatched += __listdir(ent->d_name,patlist,1,results);
	closedir(dirp);
      }
    }
    else
      nmatched = __listdir(p->name.c_str(),patlist,1,results);
  }
  else{
    if( p->iswild ){
      getcwd(tempbuf,TEMPBUF_SIZE);
      dirp = opendir(tempbuf);
      if( dirp ){
	while( (ent=readdir(dirp))!=NULL )
	  if( ischild(ent->d_name) && WildMatch(ent->d_name,p->name.c_str()) ){
	    results.push_back(ent->d_name);
	    nmatched ++;
	  }
	closedir(dirp);
      }
    }
    else{
      if( access(p->name.c_str(),F_OK) == 0 ){
	results.push_back(p->name);
	nmatched = 1;
      }
    }
  }
    
  results.sort(); // ˥

  return nmatched;
}


static int __listdir(const char *dirnam, std::list<listdirstruc> patlist, int ind,
	      std::list<std::string> &results)
{
  std::string  Name  = dirnam;
  DIR *dirp;
  struct dirent *ent;
  listdirstruc *p;
  int nmatched = 0;

  
  std::list<listdirstruc>::iterator itr=patlist.begin();
  for(int i=0; i<ind; i++)
    itr++;

  p = &(*itr);
  
  if( Name!="/" )
    Name = Name + "/";

  if( p->isdir ){
    dirp = opendir(dirnam);
    if( dirp ){
      if( p->iswild ){
	while( (ent=readdir(dirp))!=NULL )
	  if( ischild(ent->d_name) && WildMatch(ent->d_name,p->name.c_str()) )
	    nmatched += __listdir( (Name+ent->d_name).c_str() , 
				  patlist , ind+1 ,results);
	closedir(dirp);
      }
      else{
	closedir(dirp);
	nmatched = __listdir( (Name+p->name).c_str() , patlist , ind+1 ,results);
      }
    }
  }
  else{
    if( p->iswild ){
      dirp = opendir(dirnam);
      if(dirp){
	while( (ent=readdir(dirp))!=NULL )
	  if( ischild(ent->d_name) && WildMatch(ent->d_name,p->name.c_str()) ){
	    std::string path = Name;
	    path += ent->d_name;
	    results.push_back(path);
	    nmatched++;
	  }
	closedir(dirp);
      }
    }
    else{
      std::string path = Name;
      path += p->name;
      if( access(path.c_str(),F_OK)==0 ){
	results.push_back(path);
	nmatched=1;
      }
    }
  }

  return nmatched;
}

