/******************************************************************************
  ezht - Copyright (C) 2004 Tradcrafts
  This file is part of the ezht.
                                                                       
  ezht is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by the 
  Free Software Foundation;   either version 2 of the License,  or (at your 
  option) any later version.

  ezht is distributed in the hope that it will be useful, but 
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along with
  this program; see the file COPYING.  If not, write to the Free Software 
  Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/

#ifndef _STACK_H_
#define _STACK_H_

#include <vector>
#include <list>
#include <string>

void stack_init();
void stack_push(const char *stackname, const char *body);
void stack_pop(const char *stackname);

const char *stack_peep(const char *elementname,const char *default_body);

#define STACKNAME_LANG "lang"
#define LANG stack_peep(STACKNAME_LANG,"ja")

#define STACKNAME_DOCNAME "docname"
#define DOCNAME stack_peep(STACKNAME_DOCNAME,"Untitled")

#define STACKNAME_HT_HEAD    "head"
#define HT_HEAD stack_peep(STACKNAME_HT_HEAD,"")

#define STACKNAME_BODY_HEADER "body-header"
#define BODY_HEADER stack_peep(STACKNAME_BODY_HEADER,"")

#define STACKNAME_BODY_FOOTER "body-footer"
#define BODY_FOOTER stack_peep(STACKNAME_BODY_FOOTER,"")

#define STACKNAME_BODY_ATTRIBUTES "body-attributes"
#define BODY_ATTRIBUTES stack_peep(STACKNAME_BODY_ATTRIBUTES,"")



#define STACKNAME_INDEXFILE_INTRODUCTION "indexfile-introduction"
#define INDEXFILE_INTRODUCTION stack_peep(STACKNAME_INDEXFILE_INTRODUCTION,"")

#define STACKNAME_SECTION_BAR_COLOR "section-bar-color"
#define SECTION_BAR_COLOR stack_peep(STACKNAME_SECTION_BAR_COLOR,"silver")

#define STACKNAME_SECTION_MARK "section-mark"
#define SECTION_MARK stack_peep(STACKNAME_SECTION_MARK,"#")

#define STACKNAME_NUMBER_SEPARATOR "number-separator"
#define NUMBER_SEPARATOR stack_peep(STACKNAME_NUMBER_SEPARATOR,".")

#define STACKNAME_CHARSET "charset"
#ifdef unix 
#define CHARSET stack_peep(STACKNAME_CHARSET,"EUC-JP")
#else
#define CHARSET stack_peep(STACKNAME_CHARSET,"Shift_JIS")
#endif

#define STACKNAME_TEXT_INDEX "text-index"
#define TEXT_INDEX stack_peep(STACKNAME_TEXT_INDEX,"Index")

#define STACKNAME_TEXT_RELATION "text-relation"
#define TEXT_RELATION stack_peep(STACKNAME_TEXT_RELATION,"<strong>See also:</strong>")

#define STACKNAME_TEXT_SECTION_DISJOINED "text-section-disjoined"
#define TEXT_SECTION_DISJOINED stack_peep(STACKNAME_TEXT_SECTION_DISJOINED,"See --&gt;")

#define STACKNAME_ANCHOR_INDEX "anchor-index"
#define ANCHOR_INDEX stack_peep(STACKNAME_ANCHOR_INDEX,"Index")

#define STACKNAME_ANCHOR_UP "anchor-up"
#define ANCHOR_UP stack_peep(STACKNAME_ANCHOR_UP,"Up")

#define STACKNAME_ANCHOR_PREV "anchor-prev"
#define ANCHOR_PREV stack_peep(STACKNAME_ANCHOR_PREV,"&lt;Prev")

#define STACKNAME_ANCHOR_NEXT "anchor-next"
#define ANCHOR_NEXT stack_peep(STACKNAME_ANCHOR_NEXT,"Next&gt;")

#define STACKNAME_ANCHOR_BACK "anchor-back"
#define ANCHOR_BACK stack_peep(STACKNAME_ANCHOR_BACK,"Back")

#define STACKNAME_INDEXFILE "indexfile"
#define INDEXFILE stack_peep(STACKNAME_INDEXFILE,"index.html")

#define STACKNAME_FILENAME_PREFIX "filename-prefix"
#define FILENAME_PREFIX stack_peep(STACKNAME_FILENAME_PREFIX,"doc")

#define STACKNAME_FILENAME_SUFFIX "filename-suffix"
#define FILENAME_SUFFIX stack_peep(STACKNAME_FILENAME_SUFFIX,".html")

#define STACKNAME_FILENAME_RULE "filename-rule"
#define FILENAME_RULE stack_peep(STACKNAME_FILENAME_RULE,"section")

#define STACKNAME_INCLUDE_FILTER "include-filter"
#define INCLUDE_FILTER stack_peep(STACKNAME_INCLUDE_FILTER,"")

#define STACKNAME_INCLUDE_HEADER "include-header"
#define INCLUDE_HEADER stack_peep(STACKNAME_INCLUDE_HEADER,"")

#define STACKNAME_INCLUDE_FOOTER "include-footer"
#define INCLUDE_FOOTER stack_peep(STACKNAME_INCLUDE_FOOTER,"")

#define STACKNAME_TAB_SPACES "tab-spaces"
#define TAB_SPACES stack_peep(STACKNAME_TAB_SPACES,"8")


void cmd_push(std::vector<std::string> &arg);
void cmd_pop(std::vector<std::string> &arg);
void cmd_autopop(std::list<std::string> &autopop_list, std::vector<std::string> &args);

#endif
