/******************************************************************************
  ezht - Copyright (C) 2004 Tradcrafts
  This file is part of the ezht.
                                                                       
  ezht is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by the 
  Free Software Foundation;   either version 2 of the License,  or (at your 
  option) any later version.

  ezht is distributed in the hope that it will be useful, but 
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
  more details.

  You should have received a copy of the GNU General Public License along with
  this program; see the file COPYING.  If not, write to the Free Software 
  Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
******************************************************************************/

#ifndef _VFILE_H_
#define _VFILE_H_

#include <stdio.h>
#include <list>
#include <string>

class VFile
{
  bool is_clone;
  std::string fname;
  std::list<std::string>::iterator cur;
  std::list<std::string> *datas;
  
  VFile(const VFile &src);

 public:
  
  VFile(const char *_fnam);
  
  ~VFile();

  const char *get_filename();

  void puts(const char*);
  void printf(const char *fmt, ...);
  void chomp(); //ľβʸڤȤ

  void add_index(const char *index_name);
  bool seek(const std::string &index_name);

  void flush();
  void flush2(FILE *out);
  
  VFile *clone();

  void reset_filename(const char *new_fname);

  //
  void rewind();
  void each( bool (*callback)(VFile*,const char*,std::string &, std::string*) );
};

VFile* vf_open(const char *fname);
VFile* vf_search(const char *fname);
void   vf_flushall();
void   vf_flushall_to(FILE *out);

void vf_each(bool (*callback)(VFile*,const char *,std::string &,std::string*));

#endif
